/*
 * =====================================================================================
 *
 *       Filename:  main.c
 *
 *    Description:  
 *
 *        Version:  1.0.0
 *        Created:  2010.4.16
 *       Revision:  none
 *       Compiler:  Nios II 9.0 IDE
 *
 *         Author:   (AVIC)
 *			Email:  avic633@gmail.com  
 *			   QQ:  984597569
 *
 * =====================================================================================
 */

/*-----------------------------------------------------------------------------
 * Include 
 *-----------------------------------------------------------------------------*/
#include "../inc/sopc.h"
#include "system.h"
#include "sys/alt_irq.h"
#include <unistd.h>
#include <stdio.h>

/*-----------------------------------------------------------------------------
 * Variable 
 *-----------------------------------------------------------------------------*/
int key_flag = 0;

/* 
 * ===  FUNCTION  ======================================================================
 *         Name:  ISR_key
 *  Description:  
 * =====================================================================================
 */
void ISR_key(void * context,unsigned long id)
{
    key_flag = ~key_flag;        
}

/* 
 * ===  FUNCTION  ======================================================================
 *         Name:  init_key
 *  Description:  
 * =====================================================================================
 */
int init_key(void)
{
    KEY->INTERRUPT_MASK = 1;
    KEY->EDGE_CAPTURE = 0;
    
    return  alt_irq_register(KEY_IRQ,NULL,ISR_key);        
}

/* 
 * ===  FUNCTION  ======================================================================
 *         Name:  main
 *  Description:  
 * =====================================================================================
 */
int main()
{
    if(!init_key()){
        printf("register successfully!\n");
    }
    else{
        printf("Error: register failure!\n");
    }
    
    while(1){
        if(key_flag){
            LED->DATA = 1;
        }
        else{
            LED->DATA =0;
        }
    }
    
    return 0;
}

